INCLUDE "defines.asm"

; Uncomment to enable GBC double speed mode.
; DoubleSpeed		set	1

; ================================================================
; Sample player defines
; ================================================================

defsample:		macro
	dw		\1
	dw		\1End-\1
	db		bank(\1)
	endm

section "Sample RAM",wram0

SamplePlaying::		ds	1
SamplePtr:			ds	2
SampleSize:			ds	2
SampleBank:			ds	1
SampleBankCount:	ds	1
SampleVolume:		ds	1
TimerInterruptFlag:	ds	1

; ================================================================
; Sample player
; ================================================================

section "Sample player",rom0

PlaySample::
	add		a
	add		low(SampleTable)
	ld		l,a
	adc		high(SampleTable)
	sub		l
	ld		h,a
	ld		c,low(rNR51)
	ld		a,$ff
	ld		[c],a
	dec		c
	ld		a,$77
	ld		[c],a
	ld		a,$20
	ldh		[rNR32],a
	ld		a,[hl+]
	ld		h,[hl]
	ld		l,a
	
	ld		a,[hl+]
	ld		[SamplePtr],a
	ld		a,[hl+]
	ld		[SamplePtr+1],a
	ld		a,[hl+]
	ld		[SampleSize],a
	ld		a,[hl+]
	ld		[SampleSize+1],a
	ld		a,[hl+]
	ld		[SampleBank],a
	ld		a,1
	ld		[SamplePlaying],a
	ret
	
; Sample playback system.
; Make sure to set TMA to $00, set TAC to $06, and enable timer interrupt!
DoSample::
	push	af
	ld		a,[SamplePlaying]
	and		a
	jr		nz,.doplay
	xor		a
	ld		[SampleVolume],a
	inc		a
	ld		[TimerInterruptFlag],a
	pop		af
	reti
.doplay
	push	de
	push	hl
	ld		hl,SampleSize
	ld		a,[hl+]
	ld		d,[hl]
	ld		e,a
	ld		hl,SamplePtr
	ld		a,[hl+]
	ld		h,[hl]
	ld		l,a
	ld		a,[SampleBank]
	ld		[rROMB0],a
	
	ldh		a,[rNR51]
	ld		c,a
	and		%10111011
	ldh		[rNR51],a	; prevents spike on GBA
	xor		a
	ldh		[rNR30],a
	ld		a,[hl+]
	push	af
	ldh		[$ff30],a
	ld		a,[hl+]
	ldh		[$ff31],a
	ld		a,[hl+]
	ldh		[$ff32],a
	ld		a,[hl+]
	ldh		[$ff33],a
	ld		a,[hl+]
	ldh		[$ff34],a
	ld		a,[hl+]
	ldh		[$ff35],a
	ld		a,[hl+]
	ldh		[$ff36],a
	ld		a,[hl+]
	ldh		[$ff37],a
	ld		a,[hl+]
	ldh		[$ff38],a
	ld		a,[hl+]
	ldh		[$ff39],a
	ld		a,[hl+]
	ldh		[$ff3a],a
	ld		a,[hl+]
	ldh		[$ff3b],a
	ld		a,[hl+]
	ldh		[$ff3c],a
	ld		a,[hl+]
	ldh		[$ff3d],a
	ld		a,[hl+]
	ldh		[$ff3e],a
	ld		a,[hl+]
	ldh		[$ff3f],a
	ld		a,%10000000
	ldh		[rNR30],a
	ld		a,c
	ldh		[rNR51],a
	if	!def(DoubleSpeed)
		xor		a
	else
		ld		a,$80
	endc
	ldh		[rNR33],a
	ld		a,$87
	ldh		[rNR34],a
	ld		a,e
	sub		16
	ld		e,a
	jr		nc,.nocarry
	dec		d
.nocarry
	
	
	ld		a,h
	cp		$80
	jr		nz,.noreset
	ld		a,[SampleBank]
	inc		a
	ld		[SampleBank],a
	ld		a,$40
.noreset
	ld		[SamplePtr+1],a
	ld		a,l
	ld		[SamplePtr],a
	
	ld		a,d
	cp		$ff
	jr		nz,.noreset2
	xor		a
	ld		[SamplePlaying],a
	ldh		[rNR30],a
.noreset2
	ld		a,d
	ld		[SampleSize+1],a
	ld		a,e
	ld		[SampleSize],a
	
	pop		af
	swap	a
	and		$f
	ld		[SampleVolume],a
	ld		a,1
	ld		[TimerInterruptFlag],a
	pop		hl
	pop		de
	pop		af
	reti

SampleTable:
	dw		.bruh
	
.bruh			defsample	Sample_Bruh

; ================================================================

section	"Sample bank 1",ROM0
Sample_Bruh:	incbin	"res/starting_screen/samples/small_crowd.aud"
Sample_BruhEnd: