	struct OEM2X4
	bytes 1, sprite_1_1_y
	bytes 1, sprite_1_1_x
	bytes 1, sprite_1_1_tile
	bytes 1, sprite_1_1_attr
	bytes 1, sprite_1_2_y
	bytes 1, sprite_1_2_x
	bytes 1, sprite_1_2_tile
	bytes 1, sprite_1_2_attr
	bytes 1, sprite_1_3_y
	bytes 1, sprite_1_3_x
	bytes 1, sprite_1_3_tile
	bytes 1, sprite_1_3_attr
	bytes 1, sprite_1_4_y
	bytes 1, sprite_1_4_x
	bytes 1, sprite_1_4_tile
	bytes 1, sprite_1_4_attr
	
	bytes 1, sprite_2_1_y
	bytes 1, sprite_2_1_x
	bytes 1, sprite_2_1_tile
	bytes 1, sprite_2_1_attr
	bytes 1, sprite_2_2_y
	bytes 1, sprite_2_2_x
	bytes 1, sprite_2_2_tile
	bytes 1, sprite_2_2_attr
	bytes 1, sprite_2_3_y
	bytes 1, sprite_2_3_x
	bytes 1, sprite_2_3_tile
	bytes 1, sprite_2_3_attr
	bytes 1, sprite_2_4_y
	bytes 1, sprite_2_4_x
	bytes 1, sprite_2_4_tile
	bytes 1, sprite_2_4_attr
	end_struct

	struct OEM1X5
	bytes 1, sprite_1_1_y
	bytes 1, sprite_1_1_x
	bytes 1, sprite_1_1_tile
	bytes 1, sprite_1_1_attr
	bytes 1, sprite_1_2_y
	bytes 1, sprite_1_2_x
	bytes 1, sprite_1_2_tile
	bytes 1, sprite_1_2_attr
	bytes 1, sprite_1_3_y
	bytes 1, sprite_1_3_x
	bytes 1, sprite_1_3_tile
	bytes 1, sprite_1_3_attr
	bytes 1, sprite_1_4_y
	bytes 1, sprite_1_4_x
	bytes 1, sprite_1_4_tile
	bytes 1, sprite_1_4_attr
	bytes 1, sprite_1_5_y
	bytes 1, sprite_1_5_x
	bytes 1, sprite_1_5_tile
	bytes 1, sprite_1_5_attr
	end_struct

	struct OEM2X2
	bytes 1, sprite_1_1_y
	bytes 1, sprite_1_1_x
	bytes 1, sprite_1_1_tile
	bytes 1, sprite_1_1_attr
	bytes 1, sprite_1_2_y
	bytes 1, sprite_1_2_x
	bytes 1, sprite_1_2_tile
	bytes 1, sprite_1_2_attr

	bytes 1, sprite_2_1_y
	bytes 1, sprite_2_1_x
	bytes 1, sprite_2_1_tile
	bytes 1, sprite_2_1_attr
	bytes 1, sprite_2_2_y
	bytes 1, sprite_2_2_x
	bytes 1, sprite_2_2_tile
	bytes 1, sprite_2_2_attr
	end_struct

	struct OEM2X3
	bytes 1, sprite_1_1_y
	bytes 1, sprite_1_1_x
	bytes 1, sprite_1_1_tile
	bytes 1, sprite_1_1_attr
	bytes 1, sprite_1_2_y
	bytes 1, sprite_1_2_x
	bytes 1, sprite_1_2_tile
	bytes 1, sprite_1_2_attr
	bytes 1, sprite_1_3_y
	bytes 1, sprite_1_3_x
	bytes 1, sprite_1_3_tile
	bytes 1, sprite_1_3_attr

	bytes 1, sprite_2_1_y
	bytes 1, sprite_2_1_x
	bytes 1, sprite_2_1_tile
	bytes 1, sprite_2_1_attr
	bytes 1, sprite_2_2_y
	bytes 1, sprite_2_2_x
	bytes 1, sprite_2_2_tile
	bytes 1, sprite_2_2_attr
	bytes 1, sprite_2_3_y
	bytes 1, sprite_2_3_x
	bytes 1, sprite_2_3_tile
	bytes 1, sprite_2_3_attr
	end_struct

	struct OEM1X3
	bytes 1, sprite_1_1_y
	bytes 1, sprite_1_1_x
	bytes 1, sprite_1_1_tile
	bytes 1, sprite_1_1_attr
	bytes 1, sprite_1_2_y
	bytes 1, sprite_1_2_x
	bytes 1, sprite_1_2_tile
	bytes 1, sprite_1_2_attr
	bytes 1, sprite_1_3_y
	bytes 1, sprite_1_3_x
	bytes 1, sprite_1_3_tile
	bytes 1, sprite_1_3_attr
	end_struct

	struct GameObject
	bytes 1, vy
	words 1, sprites_addr
	words 1, attrs
	end_struct

	struct Map
	bytes 1, width
	bytes 1, height
	end_struct

map_rom: MACRO
Map\1Width EQU \2
Map\1Height EQU \3
Map\1:
ENDM

game_object_rom: MACRO
WIDTH_HEIGHT SET (\2 << 4 | \3) ; packs two nibbles into a byte
	dstruct GameObject, GO\1, .vy=$00,  .sprites_addr=$FFFF, .attrs=$0000
;OEM DATA
GO\1NumSprites EQU \2 * \3
GO\1NumSpritesW EQU \3
GO\1NumSpritesH EQU \2
GO\1OAMSize EQU \2 * \3 * 4
DB GO\1OAMSize ; size of OAM
COUNT_H SET 0
REPT \2
COUNT_W SET 0
REPT \3
	db \4 + COUNT_H * 16, \5 + COUNT_W * 8, \6 + (COUNT_H * GO\1NumSpritesW) * 2 + (COUNT_W * 2) , \7
COUNT_W SET COUNT_W + 1
ENDR
COUNT_H SET COUNT_H + 1
ENDR
ENDM

game_object_ram: MACRO
	dstruct GameObject, wGO\1
ENDM

; game_object_config: MACRO
;GO\1Config::
;.width:
;	db \2
;.height:
;	db \3
;.sprites:
;COUNT_H SET 0
;REPT \3
;COUNT_W SET 0
;REPT \2
;	db \4 + COUNT_H * 16, \5 + COUNT_W * 8, \6 + (COUNT_W + (COUNT_H * COUNT_W))*2, \7
;COUNT_W SET COUNT_W + 1
;ENDR
;COUNT_H SET COUNT_H + 1
;ENDR
;.sprites_end:
;.end:
;ENDM

;struct_game_object: MACRO
;wGO\1::
;.width:
;ds 1
;.height:
;ds 1
;.sprites:
;ds GO\1Config.sprites_end-GO\1Config.sprites
;.sprites_end:
;ENDM */